//+------------------------------------------------------------------+
//|                                             ATR_Chanel V.3.0.mq4 |
//|                               Copyright  2009, Glordon Software |
//|                                    http://www.tradersunion.at.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Glordon Software"
#property link      "http://www.tradersunion.at.ua"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Magenta
#property indicator_color4 Magenta
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
extern string str1=" ATR";
extern int ATRPeriod=14;
extern string str2="   %  ATR";
extern int ATRPersent=100;
extern string str3=".\.  ";
extern bool ATR_Timeframe_High=true;
extern string str4=".\.  ";
extern bool ATR_Timeframe_Cur=true;
extern string str5=".\.   (H+L)/2";
extern bool ATR_HL=true;
extern string str6="      ";
extern int CostCoef=4;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT,2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,2);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT,2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT,2);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   return(0);
  }

void Get_ATR()
{
int timeframe;
  if (ATR_Timeframe_High)
  {
   if (Period()==1)timeframe=5;
    else if (Period()==5)timeframe=15;
     else if (Period()==15)timeframe=30;
      else if (Period()==30)timeframe=60;
       else if (Period()==60)timeframe=240;
        else if (Period()==240)timeframe=1440;
         else if (Period()==1440)timeframe=10080;
          else if (Period()==10080)timeframe=43200;
         else timeframe=0;
   }
   else  timeframe=0;    
    int    i,pos=Bars;
//---- initial accumulation
   if(pos<ATRPeriod) pos=ATRPeriod;
   for(i=1;i<ATRPeriod;i++,pos--)
    double atr=iATR(NULL,timeframe, ATRPeriod,0); 
    double atrc=iATR(NULL,0,ATRPeriod,0); 
//---- main calculation loop
   if (CostCoef==2) int pic=1;
    if (CostCoef==3) pic=10;
     if(CostCoef==5) pic=1000;
      if(CostCoef==4) pic=100;
      
     while(pos>=0)
     {
      if (Open[pos]<Close[pos])
      {
       ExtMapBuffer1[pos]=Close[pos]+atr*pic*ATRPersent*Point;
	    ExtMapBuffer2[pos]=Open[pos]-atr*pic*ATRPersent*Point;
	     if (ATR_Timeframe_Cur)
	     {
	      ExtMapBuffer3[pos]=Close[pos]+atrc*pic*ATRPersent*Point;
	      ExtMapBuffer4[pos]=Open[pos]-atrc*pic*ATRPersent*Point;
	     }
	   }
	   else
	   {
	    ExtMapBuffer1[pos]=Open[pos]+atr*pic*ATRPersent*Point;
	    ExtMapBuffer2[pos]=Close[pos]-atr*pic*ATRPersent*Point;
	    if (ATR_Timeframe_Cur)
	     {
	      ExtMapBuffer3[pos]=Open[pos]+atrc*pic*ATRPersent*Point;
	      ExtMapBuffer4[pos]=Close[pos]-atrc*pic*ATRPersent*Point;
	     }
	   }  
 	   pos--;
     }
     Comment("\n",ATRPersent,"% ","ATR=",DoubleToStr(atr*pic*ATRPersent,0)," Pips");    
  }
  
  void Get_ATR_HL()
{
int timeframe;
  if (ATR_Timeframe_High)
  {
   if (Period()==1)timeframe=5;
    else if (Period()==5)timeframe=15;
     else if (Period()==15)timeframe=30;
      else if (Period()==30)timeframe=60;
       else if (Period()==60)timeframe=240;
        else if (Period()==240)timeframe=1440;
         else if (Period()==1440)timeframe=10080;
          else if (Period()==10080)timeframe=43200;
         else timeframe=0;
   }
   else  timeframe=0;    
    int    i,pos=Bars;
//---- initial accumulation
   if(pos<ATRPeriod) pos=ATRPeriod;
   for(i=1;i<ATRPeriod;i++,pos--)
    double atr=iATR(NULL,timeframe, ATRPeriod,0); 
    double atrc=iATR(NULL,0,ATRPeriod,0); 
//---- main calculation loop
   if (CostCoef==2) int pic=1;
    if (CostCoef==3) pic=10;
     if (CostCoef==5) pic=1000;
      if (CostCoef==4) pic=100;
      
     while(pos>=0)
     {
       ExtMapBuffer1[pos]=((High[pos]+Low[pos])/2)+atr*pic*ATRPersent*Point;
	    ExtMapBuffer2[pos]=((High[pos]+Low[pos])/2)-atr*pic*ATRPersent*Point;
	     if (ATR_Timeframe_Cur)
	     {
	      ExtMapBuffer3[pos]=((High[pos]+Low[pos])/2)+atrc*pic*ATRPersent*Point;
	      ExtMapBuffer4[pos]=((High[pos]+Low[pos])/2)-atrc*pic*ATRPersent*Point;
	     }
	   pos--;
     }
     Comment("\n",ATRPersent,"% ","ATR=",DoubleToStr(atr*pic*ATRPersent,0)," Pips","\n","   (High+Low)/2");
  
 }    
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if (ATR_HL)Get_ATR_HL();
   else Get_ATR();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+